<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <meta name="generator" content="pandoc" />
  <title>Test Rest</title>
  <style type="text/css">
    code{white-space: pre-wrap;}
    span.smallcaps{font-variant: small-caps;}
    span.underline{text-decoration: underline;}
    div.column{display: inline-block; vertical-align: top; width: 50%;}
    div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
    ul.task-list{list-style: none;}
    .display.math{display: block; text-align: center; margin: 0.5rem auto;}
  </style>
  <link rel="stylesheet" type="text/css" media="screen, projection, print"
    href="https://www.w3.org/Talks/Tools/Slidy2/styles/slidy.css" />
  <script src="https://www.w3.org/Talks/Tools/Slidy2/scripts/slidy.js"
    charset="utf-8" type="text/javascript"></script>
</head>
<body>
<div class="slide titlepage">
  <h1 class="title">Test Rest</h1>
</div>
<div id="declarative-rest-clients-in-tests" class="slide section level1">
<h1>Declarative REST clients in tests</h1>
<h2 id="strongly-typed-rest-calls-a.k.a.-who-needs-restassured."><strong><em>Strongly typed REST calls, a.k.a. Who needs RestAssured.</em></strong></h2>
<ul class="incremental">
<li>Are your integration tests maintainable? Fragile?</li>
<li>Are they refactoring-friendly?</li>
<li>When do you find out that you broke them (although production code is working fine)?
<ul class="incremental">
<li>At compile time?</li>
<li>Or runtime?</li>
</ul></li>
</ul>
<p>Let’s see how to improve.</p>
</div>
<div id="lets-start" class="slide section level1">
<h1>Let’s start…</h1>
<h2 id="by-writing-a-springmvc-app-and-few-tests">…by writing a SpringMVC app and few tests</h2>
<p><a href="https://gitlab.com/tech-study-materials/testrest/spring/-/blob/master/src/main/java/com/example/todoer/TodoerApplication.java">Here it is</a></p>
<p>Issues:</p>
<ul class="incremental">
<li>can you refactor models/dtos without breaking your tests?</li>
<li>can you refactor webmethod signatures without breaking your tests?</li>
<li>can you refactor urls without breaking your tests?</li>
<li><strong>and most importantly - when your tests do break, is it evident how to fix them?</strong></li>
</ul>
</div>
<div id="generate-it" class="slide section level1">
<h1>Generate it!</h1>
<h2 id="i-wish-someone-wrote-the-http-handling-code-for-me-so-i-can-just-use-my-java-interfaces"><em>I wish someone wrote the http-handling code for me, so I can just use my java interfaces…</em></h2>
<p>You’re in luck! You just need to expose a contract and run a code generator, <a href="https://gitlab.com/tech-study-materials/testrest/generated/-/tree/master/">like here</a></p>
<p>Now, try to refactor something, e.g. remove {user} from ‘DELETE todo’.</p>
<p>Clunky process, isn’t it?</p>
</div>
<div id="declare-it" class="slide section level1">
<h1>Declare it!</h1>
<h2 id="there-has-to-be-a-better-way-what-do-other-application-frameworks-offer"><em>There has to be a better way! What do other application frameworks offer?</em></h2>
<p>Yeah, let’s see. <a href="https://gitlab.com/tech-study-materials/testrest/micronaut/-/tree/master/">Micronaut is cool!</a></p>
</div>
<div id="declare-it-1" class="slide section level1">
<h1>Declare it!</h1>
<h2 id="take-me-back-to-spring-world-it-must-have-something-like-that-too"><em>Take me back to Spring world, it must have something like that too!</em></h2>
<p>Of course it does, <a href="https://gitlab.com/tech-study-materials/testrest/spring/-/tree/feign">have a look</a></p>
</div>
<div id="what-if" class="slide section level1">
<h1>What if…</h1>
<h2 id="im-in-jee-world"><em>…I’m in JEE world?</em></h2>
<p>Any spec or framework that uses annotated interfaces to declare http endpoints can benefit from declarative approach.</p>
<p>Here’s an <a href="https://gitlab.com/tech-study-materials/testrest/jee/-/tree/master">example with JAX-RS stack</a>.</p>
</div>
<div id="what-if-1" class="slide section level1">
<h1>What if…</h1>
<h2 id="my-code-doesnt-use-interface-based-endpoint-declarations"><em>…my code doesn’t use interface-based endpoint declarations?</em></h2>
<p>You mean sparkjava or java-express?</p>
<p>Or are you serving REST via Servlet API? (in that case, I’m sorry for you)</p>
<p><a href="https://gitlab.com/tech-study-materials/testrest/express/-/blob/master/src/test/java/com/example/todoer/FeignTests.java">You still can use declarative rest clients</a>, but compiler will no longer help you to the same extent. Test code will still be easier to maintain and work with, although not immune to API changes.</p>
</div>
<div id="what-if-2" class="slide section level1">
<h1>What if…</h1>
<h2 id="i-want-a-declarative-client-but-also-access-to-low-level-http-information-e.g.-status-codes"><em>…I want a declarative client BUT ALSO access to low-level http information (e.g. status codes)?</em></h2>
<p>In that case you might find <a href="https://gitlab.com/tech-study-materials/testrest/express/-/blob/master/src/test/java/com/example/todoer/RetrofitTests.java">this</a> interesting.</p>
<p>Not as safe as shared java interface (shared between server and rest client), but still useful.</p>
</div>
<div id="bonus" class="slide section level1">
<h1>Bonus</h1>
<p>Use the same test code as fast (zero-I/O) ‘unit’ tests, as well as more thorough integration tests.</p>
<ul class="incremental">
<li><a href="https://gitlab.com/tech-study-materials/testrest/micronaut/-/tree/bonus">Micronaut example</a></li>
<li><a href="https://gitlab.com/tech-study-materials/testrest/spring/-/tree/bonus">Spring example</a></li>
<li><a href="https://gitlab.com/tech-study-materials/testrest/jee/-/tree/bonus">JAX-RS example</a></li>
</ul>
<p>Just run the tests with or without:</p>
<p><code>-Dintegration-testing=true</code></p>
</div>
<div id="resources" class="slide section level1">
<h1>Resources</h1>
<ul class="incremental">
<li><a href="https://openapi-generator.tech/">OpenApi generator</a></li>
<li><a href="https://github.com/OpenFeign/feign">OpenFeign</a></li>
<li><a href="https://cloud.spring.io/spring-cloud-openfeign/reference/html/">OpenFeign in Spring</a></li>
<li><a href="https://spring.io/projects/spring-cloud">Compatibility table of Cloud&amp;Boot (Table 1)</a></li>
<li><a href="https://github.com/eclipse/microprofile-rest-client">MicroProfile Rest Client</a></li>
<li><a href="https://square.github.io/retrofit/">Retrofit</a></li>
</ul>
</div>
<div id="thank-you" class="slide section level1">
<h1>Thank you!</h1>
<p>I’m @ <a href="https://gitlab.com/tech-study-materials/testrest/readme">https://gitlab.com/tech-study-materials/testrest/readme</a></p>
</div>
</body>
</html>
